package SoftLib.constraints;

import JaCoP.constraints.Constraint;
import JaCoP.constraints.XltC;
import JaCoP.core.IntVar;
import JaCoP.core.Store;
import SoftLib.core.CoupleConstraint;
import SoftLib.core.SoftStore;
import SoftLib.weight.PrimitiveUnaryWeight;
import SoftLib.weight.PrimitiveWeight;
import SoftLib.weight.WeightUnaryProportional;

public class SoftXltC extends XltC
                            implements SoftConstraint {

    public PrimitiveUnaryWeight w;
            
    public SoftXltC(IntVar x, int c) {
        super(x, c);
    }
    
    @Override
    public void impose(Store store) {
        throw new UnsupportedOperationException("Not supported: to use soft constraints you have to define a SoftStore type store.");
    }

    public void impose(SoftStore store) {
        this.impose(store, new WeightUnaryProportional(1)); //if no weight function is passed, we assume that the weight is equal to the value of the IntVar
    }

    public void impose(SoftStore store, PrimitiveUnaryWeight w) {
        this.w = w;
        Constraint cost = w.setWeight(store, x);
        store.addToUnary(x, new CoupleConstraint(this, cost));
        super.impose(store);
    }

    @Override
    public PrimitiveWeight getWeight() {
        return w;
    }
}